# zope imports
from zope.interface import implements
from zope.component import adapts

# CMFCore imports
from Products.CMFCore.utils import getToolByName

# EasyArticle imports
from Products.EasyArticle.interfaces import IObjectManagement
from Products.EasyArticle.interfaces import IArticleContent

class ArticleObjects:
    """Adapter which provide methods to manage sub objects of easyarticle
    content objects.
    """
    implements(IObjectManagement)
    adapts(IArticleContent)

    def __init__(self, context):
        """        
        """
        self.context = context
        
    def getObjects(self, portal_types=None, sort_on="getObjPositionInParent"):
        """
        """
        # Note: Can't use here the catalog, as the sub objects are all
        # unindexed.
        
        # Note: It seems that objectValues() provides the objects by default
        # the order of getObjPositionInParent, but to be sure I have to check
        # this.
        
        if portal_types is not None:
            objects = self.context.objectValues(portal_types)
        else:
            objects = self.context.objectValues()
        
        return objects
        
