import os, sys
import glob
import doctest
import unittest
from Globals import package_home
from base import NavigationBarFunctionalTestCase
from Testing.ZopeTestCase import FunctionalDocFileSuite as Suite

from iqpp.navigation.bar.config import GLOBALS

OPTIONFLAGS = (doctest.REPORT_ONLY_FIRST_FAILURE |
               doctest.ELLIPSIS |
               doctest.NORMALIZE_WHITESPACE)

def list_doctests():
  home = package_home(GLOBALS)
  return [filename for filename in
          glob.glob(os.path.sep.join([home, '*.txt']))]

def test_suite():
  filenames = list_doctests()
  return unittest.TestSuite(
      [Suite(os.path.basename(filename),
             optionflags=OPTIONFLAGS,
             package='iqpp.navigation.bar',
             test_class=NavigationBarFunctionalTestCase)
       for filename in filenames])